pkgsrc-Bugs archive
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]
Re: pkg/39105
The following reply was made to PR pkg/39105; it has been noted by GNATS.
From: Kernigh <xkernigh%netscape.net@localhost>
To: gnats-bugs%NetBSD.org@localhost
Cc:
Subject: Re: pkg/39105
Date: Sun, 23 Nov 2008 00:49:32 +0000
I wish to append this text to Problem Report 39105
http://www.netbsd.org/cgi-bin/query-pr-single.pl?number=39105
I upgraded to NetBSD 4.0.1 and pkgsrc 2008Q3.
Here is my proposed "good fix" for the sysutils/dbus package.
This fix comes in two halves:
* a new version of patch-ac that provides --disable-pie and
--disable-gc-sections flags
* a patch to Makefile to use both new flags, but only if the
system is NetBSD and the architecture is powerpc
I posted a configure-in.patch to the upstream bug report at
https://bugs.freedesktop.org/show_bug.cgi?id=16621
I merged my changes into the existing sysutils/dbus/patches/patch-ac
that patches configure. So my copy of pkgsrc 2008Q3 is patching
configure, not configure.in.
I have inserted my patch-ac into this email. (Is it better to
provide a patch of a patch, so that someone can merge it into
pkgsrc-current? I did not find anything in
http://www.netbsd.org/support/send-pr.html to tell me how to
include a patch into a problem report.)
Here is sysutils/dbus/patches/patch-ac
$NetBSD: patch-ac,v 1.8 2008/06/13 11:28:35 drochner Exp $
--- configure.orig 2008-10-06 21:20:17.000000000 +0000
+++ configure
@@ -1589,6 +1589,8 @@ Optional Features:
--disable-libtool-lock avoid locking (might break parallel builds)
--enable-tests enable unit test code
--enable-ansi enable -ansi -pedantic gcc flags
+ --disable-pie disable -pie and related gcc flags
+ --disable-gc-sections disable -Wl,--gc-sections and related gcc flags
--enable-verbose-mode support verbose debug mode
--enable-asserts include assertion checks
--enable-checks include sanity checks on public API
@@ -5997,6 +5999,224 @@ esac
need_locks="$enable_libtool_lock"
+if test "${ac_cv_header_sys_atomic_h+set}" = set; then
+ { echo "$as_me:$LINENO: checking for sys/atomic.h" >&5
+echo $ECHO_N "checking for sys/atomic.h... $ECHO_C" >&6; }
+if test "${ac_cv_header_sys_atomic_h+set}" = set; then
+ echo $ECHO_N "(cached) $ECHO_C" >&6
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_header_sys_atomic_h" >&5
+echo "${ECHO_T}$ac_cv_header_sys_atomic_h" >&6; }
+else
+ # Is the header compilable?
+{ echo "$as_me:$LINENO: checking sys/atomic.h usability" >&5
+echo $ECHO_N "checking sys/atomic.h usability... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h. */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h. */
+$ac_includes_default
+#include <sys/atomic.h>
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+ *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+ *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+ (eval "$ac_compile") 2>conftest.er1
+ ac_status=$?
+ grep -v '^ *+' conftest.er1 >conftest.err
+ rm -f conftest.er1
+ cat conftest.err >&5
+ echo "$as_me:$LINENO: \$? = $ac_status" >&5
+ (exit $ac_status); } && {
+ test -z "$ac_c_werror_flag" ||
+ test ! -s conftest.err
+ } && test -s conftest.$ac_objext; then
+ ac_header_compiler=yes
+else
+ echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+ ac_header_compiler=no
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
+echo "${ECHO_T}$ac_header_compiler" >&6; }
+
+# Is the header present?
+{ echo "$as_me:$LINENO: checking sys/atomic.h presence" >&5
+echo $ECHO_N "checking sys/atomic.h presence... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h. */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h. */
+#include <sys/atomic.h>
+_ACEOF
+if { (ac_try="$ac_cpp conftest.$ac_ext"
+case "(($ac_try" in
+ *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+ *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+ (eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
+ ac_status=$?
+ grep -v '^ *+' conftest.er1 >conftest.err
+ rm -f conftest.er1
+ cat conftest.err >&5
+ echo "$as_me:$LINENO: \$? = $ac_status" >&5
+ (exit $ac_status); } >/dev/null && {
+ test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
+ test ! -s conftest.err
+ }; then
+ ac_header_preproc=yes
+else
+ echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+ ac_header_preproc=no
+fi
+
+rm -f conftest.err conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
+echo "${ECHO_T}$ac_header_preproc" >&6; }
+
+# So? What about this header?
+case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
+ yes:no: )
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: accepted by the compiler,
rejected by the preprocessor!" >&5
+echo "$as_me: WARNING: sys/atomic.h: accepted by the compiler, rejected by
the preprocessor!" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: proceeding with the
compiler's result" >&5
+echo "$as_me: WARNING: sys/atomic.h: proceeding with the compiler's result"
>&2;}
+ ac_header_preproc=yes
+ ;;
+ no:yes:* )
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: present but cannot be
compiled" >&5
+echo "$as_me: WARNING: sys/atomic.h: present but cannot be compiled" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: check for missing
prerequisite headers?" >&5
+echo "$as_me: WARNING: sys/atomic.h: check for missing prerequisite
headers?" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: see the Autoconf
documentation" >&5
+echo "$as_me: WARNING: sys/atomic.h: see the Autoconf documentation" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: section \"Present But
Cannot Be Compiled\"" >&5
+echo "$as_me: WARNING: sys/atomic.h: section \"Present But Cannot Be
Compiled\"" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: proceeding with the
preprocessor's result" >&5
+echo "$as_me: WARNING: sys/atomic.h: proceeding with the preprocessor's
result" >&2;}
+ { echo "$as_me:$LINENO: WARNING: sys/atomic.h: in the future, the
compiler will take precedence" >&5
+echo "$as_me: WARNING: sys/atomic.h: in the future, the compiler will take
precedence" >&2;}
+
+ ;;
+esac
+{ echo "$as_me:$LINENO: checking for sys/atomic.h" >&5
+echo $ECHO_N "checking for sys/atomic.h... $ECHO_C" >&6; }
+if test "${ac_cv_header_sys_atomic_h+set}" = set; then
+ echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+ ac_cv_header_sys_atomic_h=$ac_header_preproc
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_header_sys_atomic_h" >&5
+echo "${ECHO_T}$ac_cv_header_sys_atomic_h" >&6; }
+
+fi
+if test $ac_cv_header_sys_atomic_h = yes; then
+ { echo "$as_me:$LINENO: checking for atomic_inc_32_nv" >&5
+echo $ECHO_N "checking for atomic_inc_32_nv... $ECHO_C" >&6; }
+if test "${ac_cv_func_atomic_inc_32_nv+set}" = set; then
+ echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+ cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h. */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h. */
+/* Define atomic_inc_32_nv to an innocuous variant, in case <limits.h>
declares atomic_inc_32_nv.
+ For example, HP-UX 11i <limits.h> declares gettimeofday. */
+#define atomic_inc_32_nv innocuous_atomic_inc_32_nv
+
+/* System header to define __stub macros and hopefully few prototypes,
+ which can conflict with char atomic_inc_32_nv (); below.
+ Prefer <limits.h> to <assert.h> if __STDC__ is defined, since
+ <limits.h> exists even on freestanding compilers. */
+
+#ifdef __STDC__
+# include <limits.h>
+#else
+# include <assert.h>
+#endif
+
+#undef atomic_inc_32_nv
+
+/* Override any GCC internal prototype to avoid an error.
+ Use char because int might match the return type of a GCC
+ builtin and then its argument prototype would still apply. */
+#ifdef __cplusplus
+extern "C"
+#endif
+char atomic_inc_32_nv ();
+/* The GNU C library defines this for functions which it implements
+ to always fail with ENOSYS. Some functions are actually named
+ something starting with __ and the normal name is an alias. */
+#if defined __stub_atomic_inc_32_nv || defined __stub___atomic_inc_32_nv
+choke me
+#endif
+
+int
+main ()
+{
+return atomic_inc_32_nv ();
+ ;
+ return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext conftest$ac_exeext
+if { (ac_try="$ac_link"
+case "(($ac_try" in
+ *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+ *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+ (eval "$ac_link") 2>conftest.er1
+ ac_status=$?
+ grep -v '^ *+' conftest.er1 >conftest.err
+ rm -f conftest.er1
+ cat conftest.err >&5
+ echo "$as_me:$LINENO: \$? = $ac_status" >&5
+ (exit $ac_status); } && {
+ test -z "$ac_c_werror_flag" ||
+ test ! -s conftest.err
+ } && test -s conftest$ac_exeext &&
+ $as_test_x conftest$ac_exeext; then
+ ac_cv_func_atomic_inc_32_nv=yes
+else
+ echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+ ac_cv_func_atomic_inc_32_nv=no
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest_ipa8_conftest.oo \
+ conftest$ac_exeext conftest.$ac_ext
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_func_atomic_inc_32_nv" >&5
+echo "${ECHO_T}$ac_cv_func_atomic_inc_32_nv" >&6; }
+if test $ac_cv_func_atomic_inc_32_nv = yes; then
+
+cat >>confdefs.h <<\_ACEOF
+#define HAVE_NETBSD_ATOMIC_OPS 1
+_ACEOF
+
+fi
+
+fi
+
+
# On IRIX 5.3, sys/types and inttypes.h are conflicting.
@@ -19961,6 +20181,20 @@ else
enable_ansi=no
fi
+# Check whether --enable-pie was given.
+if test "${enable_pie+set}" = set; then
+ enableval=$enable_pie; enable_pie=$enableval
+else
+ enable_pie=yes
+fi
+
+# Check whether --enable-gc-sections was given.
+if test "${enable_gc_sections+set}" = set; then
+ enableval=$enable_gc_sections; enable_gc_sections=$enableval
+else
+ enable_gc_sections=yes
+fi
+
# Check whether --enable-verbose-mode was given.
if test "${enable_verbose_mode+set}" = set; then
enableval=$enable_verbose_mode; enable_verbose_mode=$enableval
@@ -20370,18 +20604,20 @@ if test "x$GCC" = "xyes"; then
;;
esac
- case " $CFLAGS " in
- *[\ \ ]-fPIE[\ \ ]*) ;;
- *) if cc_supports_flag -fPIE; then
- PIE_CFLAGS="-fPIE"
- if ld_supports_flag -z,relro; then
- PIE_LDFLAGS="-pie -Wl,-z,relro"
- else
- PIE_LDFLAGS="-pie"
- fi
- fi
- ;;
- esac
+ if test "x$enable_pie" = "xyes"; then
+ case " $CFLAGS " in
+ *[\ \ ]-fPIE[\ \ ]*) ;;
+ *) if cc_supports_flag -fPIE; then
+ PIE_CFLAGS="-fPIE"
+ if ld_supports_flag -z,relro; then
+ PIE_LDFLAGS="-pie -Wl,-z,relro"
+ else
+ PIE_LDFLAGS="-pie"
+ fi
+ fi
+ ;;
+ esac
+ fi
if test "x$enable_ansi" = "xyes"; then
case " $CFLAGS " in
@@ -20430,9 +20666,11 @@ fi
-if ld_supports_flag --gc-sections; then
- SECTION_LDFLAGS="-Wl,--gc-sections $SECTION_LDFLAGS"
- CFLAGS="-ffunction-sections -fdata-sections $CFLAGS"
+if test "x$enable_gc_sections" = xyes; then
+ if ld_supports_flag --gc-sections; then
+ SECTION_LDFLAGS="-Wl,--gc-sections $SECTION_LDFLAGS"
+ CFLAGS="-ffunction-sections -fdata-sections $CFLAGS"
+ fi
fi
And here is a patch for sysutils/dbus/Makefile, to tell it to
use the new configure flags only for NetBSD/powerpc. (This patch
does not increment any package revision number.)
--- ./Makefile.orig 2008-10-13 01:35:20.000000000 +0000
+++ Makefile 2008-11-14 21:58:22.000000000 +0000
@@ -59,6 +59,10 @@
CONFIGURE_ARGS.disable+=\
${CONFIGURE_ARGS.Linux}
.endif
+.if ${OPSYS} == "NetBSD" && ${MACHINE_ARCH} == "powerpc"
+# See PR ?????
+CONFIGURE_ARGS.disable+= pie gc-sections
+.endif
CONFIGURE_ARGS+=\
${CONFIGURE_ARGS_GROUPS:@.g.@ \
I used this new patch-ac and modified Makefile with pkgsrc 2008Q3
to fix this bug and install dbus-daemon.
Home |
Main Index |
Thread Index |
Old Index